//+------------------------------------------------------------------+
//|                                                     SSL fast.mq4 |
//|                                                           mladen |
//|                                                                  |
//| initial SSL for metatrader developed by Kalenzo                  |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 5
#property indicator_color1  CornflowerBlue
#property indicator_width1  3
#property indicator_color2  Red
#property indicator_width2  3
#property indicator_color3  Red
#property indicator_width3  3
#property indicator_color4  Green     
#property indicator_color5  Red

//
//
//
//
//

extern int    Lb              = 3;
extern int    MaType          = MODE_LWMA;
extern int    arrowsDistance  = 1;
extern int    arrowSize       = 2;

extern string note            = "turn on Alert = true; turn off = false";
extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = true;
extern bool   alertsEmail     = false;
extern string soundfile       = "alert2.wav";

//
//
//
//
//

double ssl[];
double sslUa[];
double sslUb[];
double arrowUp[];
double arrowDn[];
double trend[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(6);
   SetIndexBuffer(0,ssl);      SetIndexDrawBegin(0,Lb+1);
   SetIndexBuffer(1,sslUa);
   SetIndexBuffer(2,sslUb);
   SetIndexBuffer(3,arrowUp); SetIndexStyle(3,DRAW_ARROW,0,arrowSize); SetIndexArrow(3,233);
   SetIndexBuffer(4,arrowDn); SetIndexStyle(4,DRAW_ARROW,0,arrowSize); SetIndexArrow(4,234);
   SetIndexBuffer(5,trend);
   
   IndicatorShortName(" TFT ");
return(0);
}

//
//
//
//
//

int deinit() {  return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//

int start()
{
    int counted_bars = IndicatorCounted();
    int i,limit;

    if(counted_bars < 0) return(-1);
    if(counted_bars > 0) counted_bars--;
            limit = MathMin(Bars - counted_bars,Bars - 1);
            
    //
    //
    //
    //
    // 
                  
    if (trend[limit] == -1) CleanPoint(limit,sslUa,sslUb);      
      
      for(i = limit; i >= 0; i--)
      {
             sslUa[i]   = EMPTY_VALUE;
             sslUb[i]   = EMPTY_VALUE;
             arrowUp[i] = EMPTY_VALUE;
             arrowDn[i] = EMPTY_VALUE;
             trend[i]   = trend[i+1];
             
             if (Close[i] > iMA(Symbol(),0,Lb,0,MaType,PRICE_HIGH,i+1))  trend[i] =  1;
             if (Close[i] < iMA(Symbol(),0,Lb,0,MaType,PRICE_LOW, i+1))  trend[i] = -1;
             if (trend[i]!= trend[i+1])
             { 
               if (trend[i] ==  1) arrowUp[i] = Low[i]  - arrowsDistance * iATR(NULL,0,20,i);
               if (trend[i] == -1) arrowDn[i] = High[i] + arrowsDistance * iATR(NULL,0,20,i);
             }                     
      
             if (trend[i] == -1)
                   ssl[i] = iMA(Symbol(),0,Lb,0,MaType,PRICE_HIGH,i+1);
             else  ssl[i] = iMA(Symbol(),0,Lb,0,MaType,PRICE_LOW, i+1);
         
        if (trend[i] == -1) PlotPoint(i,sslUa,sslUb,ssl);
      
        }
        
        //
        //
        //
        //
        //
               
        if (alertsOn)
        {
        if (alertsOnCurrent)
             int whichBar = 0;
        else     whichBar = 1;

        //
        //
        //
        //
        //
         
        if (trend[whichBar] != trend[whichBar+1])
        if (trend[whichBar] == 1)
              doAlert(" up trend ");
        else  doAlert(" down trend ");       
   }
   return(0);           
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," TFT ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," TFT "),message);
             if (alertsSound)   PlaySound(soundfile);
      }
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
      if (first[i+2] == EMPTY_VALUE) {
          first[i]    = from[i];
          first[i+1]  = from[i+1];
          second[i]   = EMPTY_VALUE;
         }
      else {
          second[i]   = from[i];
          second[i+1] = from[i+1];
          first[i]    = EMPTY_VALUE;
         }
      }
   else
      {
         first[i]   = from[i];
         second[i]  = EMPTY_VALUE;
      }
}





